VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_closeup_window"
   ClientHeight    =   5220
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7845
   LinkTopic       =   "Form1"
   ScaleHeight     =   348
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   523
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picSmall 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3750
      Left            =   6360
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   250
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   250
      TabIndex        =   7
      Top             =   2160
      Visible         =   0   'False
      Width           =   3750
   End
   Begin VB.PictureBox picGray 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3750
      Left            =   6360
      Picture         =   "Form1.frx":2928
      ScaleHeight     =   250
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   250
      TabIndex        =   6
      Top             =   -1800
      Visible         =   0   'False
      Width           =   3750
   End
   Begin VB.Timer tmrCheckMouse 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   120
      Top             =   4200
   End
   Begin VB.PictureBox picOuter 
      BorderStyle     =   0  'None
      Height          =   3750
      Left            =   3960
      ScaleHeight     =   250
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   250
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   3750
      Begin VB.PictureBox picInner 
         AutoSize        =   -1  'True
         BorderStyle     =   0  'None
         Height          =   13500
         Left            =   0
         Picture         =   "Form1.frx":4898
         ScaleHeight     =   900
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   900
         TabIndex        =   2
         Top             =   0
         Width           =   13500
      End
   End
   Begin VB.PictureBox picWhole 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3750
      Left            =   120
      Picture         =   "Form1.frx":20E2B
      ScaleHeight     =   250
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   250
      TabIndex        =   0
      Top             =   120
      Width           =   3750
   End
   Begin VB.Label lblWebSite 
      AutoSize        =   -1  'True
      Caption         =   "Astronomy Picture of the Day web site."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   240
      Left            =   2430
      MousePointer    =   10  'Up Arrow
      TabIndex        =   5
      Top             =   4800
      Width           =   3390
   End
   Begin VB.Label Label2 
      Caption         =   "This is a picture of Saturn's moon Encaledus taken by the Casinni spacecraft. For more information, visit the"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   600
      Left            =   120
      TabIndex        =   4
      Top             =   4560
      Width           =   7575
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Move the mouse over the picture on the left to see a closeup."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   120
      TabIndex        =   3
      Top             =   4080
      Width           =   7515
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' To go to the Astronomy Picture of the Day web site.
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1
Private Const SW_SHOWMAXIMIZED = 3

' To see when the mouse leaves picWhole.
Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

Private upper_left As POINTAPI
Private lower_right As POINTAPI

' The area we are currently viewing.
Private ViewX As Integer
Private ViewY As Integer
Private ViewWidth As Integer
Private ViewHeight As Integer

' Open the Astronomy Picture of the Day web site.
Private Sub lblWebSite_Click()
    ShellExecute ByVal 0&, "open", lblWebSite.Caption, _
        vbNullString, vbNullString, SW_SHOWMAXIMIZED
End Sub

' Display the appropriate closeup.
Private Sub picWhole_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim new_x As Single
Dim new_y As Single

    If Not tmrCheckMouse.Enabled Then
        ' Calculate picWhole's screen coordinates.
        upper_left.X = ScaleX(picWhole.Left, ScaleMode, vbPixels)
        upper_left.Y = ScaleY(picWhole.Top, ScaleMode, vbPixels)
        ClientToScreen hwnd, upper_left
        lower_right.X = ScaleX(picWhole.Left + picWhole.Width, ScaleMode, vbPixels)
        lower_right.Y = ScaleY(picWhole.Top + picWhole.Height, ScaleMode, vbPixels)
        ClientToScreen hwnd, lower_right

        ' Display the closeup image.
        picOuter.Visible = True

        ' Display the grayed-out image.
        picWhole.Picture = picGray.Picture

        ' Start the timer to see when the mouse leaves picWhole.
        tmrCheckMouse.Enabled = True
    End If

    ' Position picInner inside its parent to show the closeup.
    new_x = CSng(X) / picWhole.Width * picInner.Width - CSng(picOuter.Width) / 2
    new_y = CSng(Y) / picWhole.Height * picInner.Height - CSng(picOuter.Height) / 2
    If (new_x < 0) Then new_x = 0
    If (new_y < 0) Then new_y = 0
    If (new_x > picInner.Width - picOuter.Width) Then
        new_x = picInner.Width - picOuter.Width
    End If
    If (new_y > picInner.Height - picOuter.Height) Then
        new_y = picInner.Height - picOuter.Height
    End If
    picInner.Left = -CInt(new_x)
    picInner.Top = -CInt(new_y)

    ' Record the area we are viewing.
    ViewWidth = picOuter.Width * picSmall.Width / picInner.Width
    ViewHeight = picOuter.Height * picSmall.Height / picInner.Height
    ViewX = X - ViewWidth / 2
    ViewY = Y - ViewHeight / 2

    ' Draw the closeup area.
    picWhole.Refresh
End Sub

' Draw the current viewing area.
Private Sub picWhole_Paint()
    If Not tmrCheckMouse.Enabled Then Exit Sub

    ' Draw the viewing area from picSmall onto picWhole.
    picWhole.PaintPicture picSmall.Picture, _
        ViewX, ViewY, ViewWidth, ViewHeight, _
        ViewX, ViewY, ViewWidth, ViewHeight
End Sub

' See if the mouse has left picWhole.
Private Sub tmrCheckMouse_Timer()
Dim pt As POINTAPI

    ' Get the cursor position.
    GetCursorPos pt

    ' See if the mouse is over the button.
    If pt.X < upper_left.X Or pt.X > lower_right.X Or _
       pt.Y < upper_left.Y Or pt.Y > lower_right.Y _
    Then
        ' It is no longer over the button.
        tmrCheckMouse.Enabled = False

        ' Display the clear image.
        picWhole.Picture = picSmall.Picture
        picOuter.Visible = False
    End If
End Sub
